SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Tests'!

TestCase subclass: #MDTestImageProxy
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestImageProxy methodsFor: 'constructing' stamp: 'cwp 11/28/2004 16:57'!
elementForSelector: aSelector
	^ (MDMethodElement className: 'Test' selector: aSelector)! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 16:59'!
methodProperty: aSymbol atSelector: aSelector
	self subclassResponsibility! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/28/2004 16:58'!
testLoadDefinition
	| snap |
	snap _ self methodSnapshot: #method1.
	snap properties at: #source put: '2'.
	proxy loadSnapshot: snap.
	self assert: (self methodProperty: #source atSelector: #method1) = '2'! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 16:49'!
proxyClass
	self subclassResponsibility! !

!MDTestImageProxy methodsFor: 'running' stamp: 'cwp 11/28/2004 16:49'!
setUp
	proxy _ self proxyClass new! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/28/2004 16:55'!
testLoadAndUpdate
	| original retrieved |
	original _ self methodSnapshot: #method1.
	original properties 
		at: #source put: '1';
		at: #author put: '2'.
	proxy loadSnapshot: original.
	
	retrieved _ self methodSnapshot: #method1.
	proxy updateSnapshot: retrieved.
	self assert: original properties = retrieved properties! !

!MDTestImageProxy methodsFor: 'constructing' stamp: 'cwp 11/28/2004 16:57'!
methodSnapshot: aSymbol
	^ MDElementDefinition forElement: (self elementForSelector: aSymbol)! !

!MDTestImageProxy class methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2004 16:57'!
isAbstract
	^ self name = #MDTestImageProxy! !

MDTestImageProxy subclass: #MDTestFakeImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 15:41'!
methodProperty: aSymbol atSelector: aSelector
	| element |
	element _ self elementForSelector: aSelector.
	^ (proxy at: element) at: aSymbol ifAbsent: [nil]! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 15:44'!
methodProperty: aSymbol atSelector: aSelector put: aString
	| element |
	element _ self elementForSelector: aSelector.
	(proxy at: element) at: aSymbol put: aString! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 16:55'!
proxyClass
	^ MDFakeImageProxy! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 16:59'!
methodProperty: aSymbol atSelector: aSelector put: aString
	self subclassResponsibility! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/28/2004 16:56'!
testCurrentDefinition
	| snap |
	self methodProperty: #source atSelector: #method1 put: '1'.
	snap _ self methodSnapshot: #method1.
	proxy updateSnapshot: snap.
	self assert: snap element selector = #method1.
	self assert: (snap properties at: #source) = '1'.! !

Object subclass: #MDProgramElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDProgramElement subclass: #MDMethodElement
	instanceVariableNames: 'className selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 13:01'!
update: propDict from: anImageProxy
	anImageProxy update: propDict forMethodElement: self! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:02'!
initializeWithClassName: aString selector: aSymbol
	className _ aString.
	selector _ aSymbol! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 11/28/2004 15:23'!
hash
	^ (className, '|', selector) hash! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 11/28/2004 15:21'!
= other
	^ self class = other class 
		and: [className = other className] 
		and: [self selector = other selector]! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
className
	^ className! !

!MDMethodElement methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:59'!
load: propDict into: anImageProxy
	anImageProxy load: propDict forMethodElement: self! !

!MDMethodElement class methodsFor: 'as yet unclassified' stamp: 'avi 11/28/2004 16:02'!
className: aString selector: aSymbol
	^ self basicNew initializeWithClassName: aString selector: aSymbol! !

!MDProgramElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

!MDProgramElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

!MDProgramElement methodsFor: 'image proxy' stamp: 'avi 11/28/2004 16:08'!
update: propDict from: anImageProxy
	self subclassResponsibility! !

!MDProgramElement methodsFor: 'image proxy' stamp: 'avi 11/28/2004 16:08'!
load: propDict into: anImageProxy
	self subclassResponsibility! !

Object subclass: #MDElementDefinition
	instanceVariableNames: 'element properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementDefinition methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDElementDefinition class methodsFor: 'instance creation' stamp: 'cwp 11/28/2004 12:52'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'cwp 11/28/2004 12:56'!
element
	^ element! !

!MDElementDefinition methodsFor: 'initialize-release' stamp: 'cwp 11/28/2004 12:52'!
initializeWithElement: anElement
	element _ anElement.
	properties _ Dictionary new! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:55'!
updateFrom: anImageProxy
	element update: properties from: anImageProxy! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:54'!
loadInto: anImageProxy
	element load: properties into: anImageProxy! !

Object subclass: #MDImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDImageProxy subclass: #MDFakeImageProxy
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFakeImageProxy methodsFor: 'public' stamp: 'cwp 11/28/2004 15:34'!
update: propDict forMethodElement: aMethodElement
	(self at: aMethodElement)
		keysAndValuesDo: [:prop :value | propDict at: prop put: value]! !

!MDFakeImageProxy methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:23'!
initialize
	dict _ Dictionary new! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:35'!
at: anElement
	^ dict at: anElement ifAbsentPut: [Dictionary new]! !

!MDFakeImageProxy methodsFor: 'public' stamp: 'cwp 11/28/2004 15:38'!
load: propDict forMethodElement: aMethodElement
	self at: aMethodElement put: propDict! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:07'!
loadSnapshot: aSnapshot
	aSnapshot loadInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:06'!
updateSnapshot: aSnapshot
	aSnapshot updateFrom: self! !
